libzypp: zyppng::detail Namespace Reference

libzypp 17.38.14

zyppng::detail Namespace Reference

## Classes
struct | add_type_to_collection
| this adds the type NewType to the collection if the condition is true More...
struct | add_type_to_collection< Templ, NewType, Templ< Types... >, false >
struct | add_type_to_collection< Templ, NewType, Templ< Types... >, true >
struct | and_then_helper
struct | collect_helper
struct | collect_transitions
struct | collect_transitions_helper
| collect all transitions that have the same SourceState as the first type argument More...
struct | collect_transitions_helper< State, TupleSoFar, Head >
struct | ContinueUntilValidPredicate
struct | expected_result_helper
struct | FirstOfHelper
struct | FirstOfImpl
struct | inspect_err_helper
struct | inspect_helper
struct | is_same_state
| Evaluates to true if type A and type B wrap the same State type. More...
struct | lifter
struct | LiftImpl
struct | LogicBaseExec
struct | LogicBaseExec< Op, std::enable_if_t< detail::is_async_op_v< Op > > >
struct | make_state_set
struct | make_state_set_helper
| Iterates over the list of Transitions and collects them all in a std::variant<State1, State2, ...> type. More...
struct | make_state_set_helper< VariantSoFar, Head >
struct | make_statewithtransition
| Turns a State type into its StateWithTransitions counterpart. More...
struct | make_statewithtransition_set
struct | make_statewithtransition_set< NoState, std::variant< HeadState, States... >, Transitions... >
struct | make_statewithtransition_set_helper
| Iterates over each State in the StateVariant argument, collects the corresponding Transitions and combines the results in a std::variant< StateWithTransitions<...>,... > type. More...
struct | make_statewithtransition_set_helper< VariantSoFar, std::variant< HeadState >, Transitions... >
struct | make_statewithtransition_set_helper< VariantSoFar, std::variant< HeadState, State... >, Transitions... >
struct | mtry_helper
struct | MtryImpl
struct | or_else_helper
struct | RedoWhileHelper
struct | RedoWhileImpl
class | ReportHolder
class | ReportHolder< Report, false >
class | ReportHolder< Report, true >
struct | showme
struct | StateWithTransitions
struct | transform_collect_helper
struct | TransformImpl

## Typedefs
template<typename T>
using | EventSource = SignalProxy<void()> (T::*)()
template<typename Function, typename ArgType>
using | mbind_cb_result_t = typename std::conditional_t< std::is_same_v<ArgType,void>, std::invoke_result<Function>,std::invoke_result<Function, ArgType> >::type

## Functions
void | preconditionViolated (const char *file, int line, const char *func, const char *expr, const char *msg)
template<typename Variant, typename Type, template< typename, typename > typename Compare = std::is_same, size_t I = 0>
constexpr bool | VariantHasType ()
| Constexpr function that evaluates to true if a variant type Variant already contains the type Type.
template<typename Excpt, typename ... Rest>
bool | containsOneOfExceptionImpl (const std::exception_ptr &exceptionPtr)
template<typename T>
bool | waitForCanContinueExpected (const expected< T > &value)
template<typename ResultType, typename E>
ResultType | expected_make_error (E &&error)
template<typename ResultType>
ResultType | expected_forward (ResultType &&res)

## Typedef Documentation

## ◆ EventSource

template<typename T>

using zyppng::detail::EventSource = SignalProxy<void()> (T::*)()

Definition at line 31 of file statemachine.h.

## ◆ mbind_cb_result_t

template<typename Function, typename ArgType>

using zyppng::detail::mbind_cb_result_t = typename std::conditional_t< std::is_same_v<ArgType,void>, std::invoke_result<Function>,std::invoke_result<Function, ArgType> >::type

Definition at line 482 of file expected.h.

## Function Documentation

## ◆ preconditionViolated()

void zyppng::detail::preconditionViolated | ( | const char * | file,
|  | int | line,
|  | const char * | func,
|  | const char * | expr,
|  | const char * | msg )
| inline

Definition at line 51 of file precondition.h.

## ◆ VariantHasType()

template<typename Variant, typename Type, template< typename, typename > typename Compare = std::is_same, size_t I = 0>

bool zyppng::detail::VariantHasType | ( |  | ) |
| constexpr

Constexpr function that evaluates to true if a variant type Variant already contains the type Type.

The Compare argument can be used to change how equality of a type is calculated

Definition at line 105 of file statemachine.h.

## ◆ containsOneOfExceptionImpl()

template<typename Excpt, typename ... Rest>

bool zyppng::detail::containsOneOfExceptionImpl | ( | const std::exception_ptr & | exceptionPtr | ) |

Definition at line 101 of file algorithm.h.

## ◆ waitForCanContinueExpected()

template<typename T>

bool zyppng::detail::waitForCanContinueExpected | ( | const expected< T > & | value | ) |

Definition at line 485 of file expected.h.

## ◆ expected_make_error()

template<typename ResultType, typename E>

ResultType zyppng::detail::expected_make_error | ( | E && | error | ) |

Definition at line 503 of file expected.h.

## ◆ expected_forward()

template<typename ResultType>

ResultType zyppng::detail::expected_forward | ( | ResultType && | res | ) |

Definition at line 508 of file expected.h.